module.exports = (bookshelf) ->
  bookshelf.plugin 'registry'

  unless bookshelf.model('AuthGroup')?
    require('./auth_permission') bookshelf

    bookshelf.model 'AuthGroup',
      tableName: 'auth_group'

      permissions: () -> @belongsToMany 'AuthPermission', 'auth_group_permissions', 'group_id', 'permission_id'

      getPermissions: () ->
        @load ['permissions']
        .then (group) -> group.related('permissions').getPermissions()

  unless bookshelf.collection('AuthGroups')?
    bookshelf.collection 'AuthGroups',
      model: bookshelf.model 'AuthGroup'

      getPermissions: () ->
        @reduce (permissions, group) ->
          permissions.concat group.getPermissions()
        , []

  Model: bookshelf.model 'AuthGroup'
  Collection: bookshelf.model 'AuthGroups'
