Promise = require 'bluebird'

module.exports = (bookshelf) ->
  bookshelf.plugin 'registry'

  unless bookshelf.model('AuthUser')?
    require('./auth_permission') bookshelf
    require('./auth_group') bookshelf

    bookshelf.model 'AuthUser',
      tableName: 'auth_user'

      permissions: () -> @belongsToMany 'AuthPermission', 'auth_user_user_permissions', 'user_id', 'permission_id'

      groups: () -> @belongsToMany 'AuthGroup', 'auth_user_groups', 'user_id', 'group_id'

      getPermissions: Promise.method () ->
        formatPerm = (perms, perm) -> perms.concat perm.formatPerm()

        unless @get 'is_active'
          return Promise.resolve []

        if @get 'is_superuser'
          bookshelf.collection 'AuthPermissions'
          .forge()
          .fetch withRelated: 'contentType'
          .then (allPermissions) -> allPermissions.getPermissions()
        else
          _user = null
          _permissions = null
          @load ['permissions', 'groups']
          .then (user) ->
            _user = user
            bookshelf.collection('AuthGroups').forge(user.related('groups')).getPermissions()
          .then (permissions) ->
            console.log permissions
            _permissions = permissions
            bookshelf.collection('AuthPermissions').forge(_user.related('permissions')).getPermissions()
          .then (permissions) ->
            _permissions.concat permissions

  unless bookshelf.collection('AuthUsers')?
    bookshelf.collection 'AuthUsers',
      model: bookshelf.model 'AuthUser'

  Model: bookshelf.model 'AuthUser'
  Collection: bookshelf.model 'AuthUsers'
